﻿using System.ComponentModel;

namespace DataBindingIssue
{
    public class DemoClass : INotifyPropertyChanged
    {
        private string _anyString;

        public string AnyString
        {
            get { return _anyString; }
            set
            {
                if (_anyString != value)
                {
                    _anyString = value.ToUpper();
                    OnPropertyChanged("AnyString");
                    OnPropertyChanged("Result");
                }
            }
        }

        private int _anyNumber;

        public int AnyNumber
        {
            get { return _anyNumber; }
            set
            {
                if (_anyNumber != value)
                {
                    int number;
                    if (int.TryParse(value.ToString(), out number))
                    {
                        _anyNumber = number*2;
                        OnPropertyChanged("AnyNumber");
                        OnPropertyChanged("Result");
                    }
                }
            }
        }

        public string Result
        {
            get { return $"{AnyString} {AnyNumber}"; }
        }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        private void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        #endregion
    }
}